#ifndef MAIN_H
#define MAIN_H

extern GFX_INFO gfx_Info;

extern unsigned long* RDP_PC;
extern unsigned long inst1, inst2;
extern int width, height;
extern void (*dp_command[256])();

typedef struct _Rdp_status
{
	struct
	{
		double uls;
		double ult;
		double lrs;
		double lrt;
	
		int format;
		int size;
		int line;
		int tmem;
		unsigned char *tmem_addr;
		int palette;
		int cmt;
		int maskt;
		int shiftt;
		int cms;
		int masks;
		int shifts;
	
		//------------
		int mipmap_level;
		int on;
		double scale_s;
		double scale_t;
	} tiles[8];
	unsigned char tmem[4096];

	int intern_w;
	int intern_h;
	int timg_fmt;
	int timg_size;
	int timg_width;
	int timg_dxt;
	int timg_block_size;
	int timg_crc;
	unsigned char *timg_addr;
	unsigned char palette[512];
	int palette_crc[17];

	// ------------------hle --------------------
	unsigned long segment[16];
	int tile;

	struct
	{
		short ob[3];
		unsigned short flag;
		float tc[2];
		unsigned char cn[4]; // Attention peut aussi etre une normale
	} Vtx[16];

	//othermode_h
	int cycle_type;
	int texturelut;
} Rdp_status;

extern Rdp_status rdp_Status;

void DP_ENDDL();
void DP_NOOP();
void DP_MTX();
void DP_NI();
void DP_MOVEMEM();
void DP_VTX();
void DP_DL();
void DP_RDPHALF_CONT();
void DP_RDPHALF_2();
void DP_RDPHALF_1();
void DP_CLEARGEOMETRYMODE();
void DP_SETGEOMETRYMODE();
void DP_SETOTHERMODE_L();
void DP_SETOTHERMODE_H();
void DP_TEXTURE();
void DP_MOVEWORD();
void DP_POPMTX();
void DP_TRI1();
void DP_TEXRECT();
void DP_LOADSYNC();
void DP_PIPESYNC();
void DP_TILESYNC();
void DP_FULLSYNC();
void DP_SETSCISSOR();
void DP_SETPRIMDEPTH();
void DP_SETOTHERMODE();
void DP_LOADTLUT();
void DP_SETTILESIZE();
void DP_LOADBLOCK();
void DP_LOADTILE();
void DP_SETTILE();
void DP_FILLRECT();
void DP_SETFILLCOLOR();
void DP_SETFOGCOLOR();
void DP_SETBLENDCOLOR();
void DP_SETPRIMCOLOR();
void DP_SETENVCOLOR();
void DP_SETCOMBINE();
void DP_SETTIMG();
void DP_SETZIMG();
void DP_SETCIMG();

#endif
