//#include <windows.h>
#include <stdio.h>
#include "../tinygl/GL/gl.h"
#include "winlnxdefs.h"
#include "Gfx_#1.3.h"
#include "main.h"
#include "texture.h"

void DP_ENDDL()
{
}

void DP_MTX()
{
	unsigned long addr;     
	int i;
	float m[16];
   
	inst2 = *(RDP_PC+1);
	addr = rdp_Status.segment[(inst2 >> 24) & 0xF] + (inst2 & 0xFFFFFF);
   
	for (i=0; i<16; i++)
		m[i] = ((*(unsigned short*)(gfx_Info.RDRAM + ((addr+i*2)^2)) << 16)
		| (*(unsigned short*)(gfx_Info.RDRAM + ((addr+16*2+i*2)^2)))) / 65536.0;

	switch((inst1 >> 16) & 0xFF)
	{
	case 0: // mul modelview no push
		glMatrixMode(GL_MODELVIEW);
		glMultMatrixf(m);
		break;
	case 1: // mul projection
		glMatrixMode(GL_PROJECTION);
		glMultMatrixf(m);
		break;
	case 2: // load modelview no push
		glMatrixMode(GL_MODELVIEW);
		glLoadMatrixf(m);
		break;
	case 3: // load projection
		glMatrixMode(GL_PROJECTION);
		glLoadMatrixf(m);
		break;
	case 4: // push mul modelview
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glMultMatrixf(m);
		break;
	case 6: // load modelview push
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glLoadMatrixf(m);
		break;
	//default:
		//printf("MATRIX inconnu : %x\n", (int)((inst1 >> 16) & 0xFF));
		//sp_register.halt=1;
		//stop=1;
     }
}

void DP_MOVEMEM()
{
}

void DP_VTX()
{
	int i, v0, n;
	unsigned long addr;
	inst2 = *(RDP_PC+1);
	addr = rdp_Status.segment[(inst2 >> 24) & 0xF] + (inst2 & 0xFFFFFF);
	v0 = (inst1 >> 16) & 0xF;
	n = ((inst1 >> 20) & 0xF) + 1;
   
	for (i=0; i<n; i++)
	{
		rdp_Status.Vtx[v0+i].ob[0] = *(short*)(gfx_Info.RDRAM + ((addr+16*i)^2));
		rdp_Status.Vtx[v0+i].ob[1] = *(short*)(gfx_Info.RDRAM + ((addr+2+16*i)^2));
		rdp_Status.Vtx[v0+i].ob[2] = *(short*)(gfx_Info.RDRAM + ((addr+4+16*i)^2));
		rdp_Status.Vtx[v0+i].flag = *(short*)(gfx_Info.RDRAM + ((addr+6+16*i)^2));
		rdp_Status.Vtx[v0+i].tc[0] = *(short*)(gfx_Info.RDRAM + ((addr+8+16*i)^2));
		rdp_Status.Vtx[v0+i].tc[1] = *(short*)(gfx_Info.RDRAM + ((addr+10+16*i)^2));
		rdp_Status.Vtx[v0+i].cn[0] = *(char*)(gfx_Info.RDRAM + ((addr+12+16*i)^3));
		rdp_Status.Vtx[v0+i].cn[1] = *(char*)(gfx_Info.RDRAM + ((addr+13+16*i)^3));
		rdp_Status.Vtx[v0+i].cn[2] = *(char*)(gfx_Info.RDRAM + ((addr+14+16*i)^3));
		rdp_Status.Vtx[v0+i].cn[3] = *(char*)(gfx_Info.RDRAM + ((addr+15+16*i)^3));
	}
}

void DP_DL()
{
	inst2 = *(RDP_PC+1);
	if (!((inst1 >> 16) & 0xFF)) // PUSH
	{
		unsigned long *addresse_retour = RDP_PC;

		RDP_PC = (unsigned long*)(gfx_Info.RDRAM +
			rdp_Status.segment[(inst2 >> 24) & 0xF] + (inst2 & 0xFFFFFF));
		do
		{
			inst1 = *RDP_PC;
			dp_command[inst1 >> 24]();
			RDP_PC += 2;
		} while (dp_command[inst1 >> 24] != DP_ENDDL);
		inst1 = 0;
		RDP_PC = addresse_retour;
	}
	else
	{
		RDP_PC = (unsigned long*)(gfx_Info.RDRAM +
			rdp_Status.segment[(inst2 >> 24) & 0xF] + (inst2 & 0xFFFFFF));
	}
}

void DP_RDPHALF_CONT()
{
}

void DP_RDPHALF_2()
{
}

void DP_RDPHALF_1()
{
}

void DP_CLEARGEOMETRYMODE()
{
}

void DP_SETGEOMETRYMODE()
{
}

void DP_SETOTHERMODE_L()
{
}

void DP_SETOTHERMODE_H()
{
	inst2 = *(RDP_PC+1);
	switch((inst1 >> 8) & 0xFF)
	{
	case 0xe: //TextLut
		rdp_Status.texturelut = (inst2 >> 14) & 3;
		break;
	case 0x14: //setcycletype
		rdp_Status.cycle_type = (inst2 >> 20) & 3;
		break;
	}
}

void DP_TEXTURE()
{
	int t = (inst1 >> 8) & 0x7;
	inst2 = *(RDP_PC+1);
	rdp_Status.tile = t;
	rdp_Status.tiles[t].mipmap_level = (inst1 >> 11) & 0x7;
	rdp_Status.tiles[t].on = inst1 & 0xFF;
	rdp_Status.tiles[t].scale_s = ((inst1 >> 16) & 0xFFFF) / 65536.0;
	rdp_Status.tiles[t].scale_t = (inst1 & 0xFFFF) / 65536.0;
}

void DP_MOVEWORD()
{
	inst2 = *(RDP_PC+1);
	switch(inst1 & 0xFF)
	{
	case 0x6:
		rdp_Status.segment[(inst1 >> 10) & 0xF] = inst2;
		break;
	}
}

void DP_POPMTX()
{
	inst2 = *(RDP_PC+1);
	switch(inst2)
	{
	case 0:
		glMatrixMode(GL_MODELVIEW);
		glPopMatrix();
		break;
	//default:
		//printf("POPMTX inconnu : %x\n", (int)(inst2));
		//sp_register.halt=1;
		//stop=1;
	}
}

void DP_TRI1()
{
	int w = (int)(rdp_Status.tiles[rdp_Status.tile].lrs - 
		rdp_Status.tiles[rdp_Status.tile].uls+1);
	int h = (int)(rdp_Status.tiles[rdp_Status.tile].lrt - 
		rdp_Status.tiles[rdp_Status.tile].ult+1);

	int v[4];
	inst2 = *(RDP_PC+1);
	v[0] = ((inst2 >> 16) & 0xFF) / 10;
	v[1] = ((inst2 >> 8) & 0xFF) / 10;
	v[2] = (inst2 & 0xFF) / 10;
	v[3] = (inst2 >> 24) & 0xFF;
   
	//load_texture(rdp_status.tile);
   
	glEnable(GL_ALPHA_TEST);
//	glAlphaFunc(GL_NOTEQUAL, 0.0);
	glDisable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
   
	glColor3f(0.0, 0.0, 0.0);
   
	//glBegin(GL_TRIANGLES);
	//glTexCoord2d(rdp_status.Vtx[v[0]].tc[0]*rdp_status.tiles[rdp_status.tile].scale_s/(float)w,
	//	rdp_status.Vtx[v[0]].tc[1]*rdp_status.tiles[rdp_status.tile].scale_t/(float)h);
	/*glNormal3b(rdp_status.Vtx[v[0]].cn[0], rdp_status.Vtx[v[0]].cn[1], 
		rdp_status.Vtx[v[0]].cn[2]);*/
	//glVertex3f((float)rdp_status.Vtx[v[0]].ob[0],
	//	(float)rdp_status.Vtx[v[0]].ob[1],
	//	(float)rdp_status.Vtx[v[0]].ob[2]);
	//glTexCoord2d(rdp_status.Vtx[v[1]].tc[0]*rdp_status.tiles[rdp_status.tile].scale_s/(float)w,
	//	rdp_status.Vtx[v[1]].tc[1]*rdp_status.tiles[rdp_status.tile].scale_t/(float)h);
	/*glNormal3b(rdp_status.Vtx[v[1]].cn[0], rdp_status.Vtx[v[1]].cn[1], 
		rdp_status.Vtx[v[1]].cn[2]);*/
	//glVertex3f((float)rdp_status.Vtx[v[1]].ob[0],
	//	(float)rdp_status.Vtx[v[1]].ob[1],
	//	(float)rdp_status.Vtx[v[1]].ob[2]);
	//glTexCoord2d(rdp_status.Vtx[v[2]].tc[0]*rdp_status.tiles[rdp_status.tile].scale_s/(float)w,
	//	rdp_status.Vtx[v[2]].tc[1]*rdp_status.tiles[rdp_status.tile].scale_t/(float)h);
	/*glNormal3b(rdp_status.Vtx[v[2]].cn[0], rdp_status.Vtx[v[2]].cn[1], 
		rdp_status.Vtx[v[2]].cn[2]);*/
	//glVertex3f((float)rdp_status.Vtx[v[2]].ob[0],
	//	(float)rdp_status.Vtx[v[2]].ob[1],
	//	(float)rdp_status.Vtx[v[2]].ob[2]);
	//glEnd();

	glDisable(GL_TEXTURE_2D);

	glColor3f(0.0, 1.0, 0.0);
	glBegin(GL_LINE_STRIP);
	glVertex3f(	(float)rdp_Status.Vtx[v[0]].ob[0],
				(float)rdp_Status.Vtx[v[0]].ob[1],
				(float)rdp_Status.Vtx[v[0]].ob[2]);
	glVertex3f(	(float)rdp_Status.Vtx[v[1]].ob[0],
				(float)rdp_Status.Vtx[v[1]].ob[1],
				(float)rdp_Status.Vtx[v[1]].ob[2]);
	glVertex3f(	(float)rdp_Status.Vtx[v[2]].ob[0],
				(float)rdp_Status.Vtx[v[2]].ob[1],
				(float)rdp_Status.Vtx[v[2]].ob[2]);
	glVertex3f(	(float)rdp_Status.Vtx[v[0]].ob[0],
				(float)rdp_Status.Vtx[v[0]].ob[1],
				(float)rdp_Status.Vtx[v[0]].ob[2]);
	glEnd();
}
